Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Member Functions | Static Protected Member Functions | Protected Attributes
Lucene::IndexReader Class Referenceabstract

IndexReader is an abstract class, providing an interface for accessing an index. Search of an index is done entirely through this abstract interface, so that any subclass which implements it is searchable. More...

`#include <IndexReader.h>`

Inheritance diagram for Lucene::IndexReader:

## Public Types

enum | FieldOption { FIELD_OPTION_ALL, FIELD_OPTION_INDEXED, FIELD_OPTION_STORES_PAYLOADS, FIELD_OPTION_OMIT_TERM_FREQ_AND_POSITIONS, FIELD_OPTION_UNINDEXED, FIELD_OPTION_INDEXED_WITH_TERMVECTOR, FIELD_OPTION_INDEXED_NO_TERMVECTOR, FIELD_OPTION_TERMVECTOR, FIELD_OPTION_TERMVECTOR_WITH_POSITION, FIELD_OPTION_TERMVECTOR_WITH_OFFSET, FIELD_OPTION_TERMVECTOR_WITH_POSITION_OFFSET }
| Constants describing field properties, for example used for IndexReader#getFieldNames(FieldOption). More...

## Public Member Functions

| IndexReader ()
virtual | ~IndexReader ()
virtual String | getClassName ()
boost::shared_ptr< IndexReader > | shared_from_this ()
int32_t | getRefCount ()
| Returns the current refCount for this reader. More...
void | incRef ()

Increments the refCount of this IndexReader instance. RefCounts are used to determine when a reader can be closed safely, i.e. as soon as there are no more references. Be sure to always call a corresponding decRef, in a finally clause; otherwise the reader may never be closed. Note that close simply calls decRef(), which means that the IndexReader will not really be closed until decRef has been called for all outstanding references. More...

void | decRef ()
| Decreases the refCount of this IndexReader instance. If the refCount drops to 0, then pending changes (if any) are committed to the index and this reader is closed. More...
virtual IndexReaderPtr | reopen ()
| Refreshes an IndexReader if the index has changed since this instance was (re)opened. More...
virtual IndexReaderPtr | reopen (bool openReadOnly)
| Just like reopen(), except you can change the readOnly of the original reader. If the index is unchanged but readOnly is different then a new reader will be returned. More...
virtual IndexReaderPtr | reopen (const IndexCommitPtr &commit)
| Reopen this reader on a specific commit point. This always returns a readOnly reader. If the specified commit point matches what this reader is already on, and this reader is already readOnly, then this same instance is returned; if it is not already readOnly, a readOnly clone is returned. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Efficiently clones the IndexReader (sharing most internal state). More...
virtual LuceneObjectPtr | clone (bool openReadOnly, const LuceneObjectPtr &other=LuceneObjectPtr())
| Clones the IndexReader and optionally changes readOnly. A readOnly reader cannot open a writable reader. More...
virtual DirectoryPtr | directory ()
| Returns the directory associated with this index. The default implementation returns the directory specified by subclasses when delegating to the IndexReader(Directory) constructor, or throws an UnsupportedOperation exception if one was not specified. More...
virtual int64_t | getVersion ()
| Version number when this IndexReader was opened. Not implemented in the IndexReader base class. More...
virtual MapStringString | getCommitUserData ()
| Retrieve the String userData optionally passed to IndexWriter::commit. This will return null if IndexWriter#commit(MapStringString) has never been called for this index. More...
virtual bool | isCurrent ()
| Check whether any new changes have occurred to the index since this reader was opened. More...
virtual bool | isOptimized ()
| Checks is the index is optimized (if it has a single segment and no deletions). Not implemented in the IndexReader base class. More...
virtual Collection< TermFreqVectorPtr > | getTermFreqVectors (int32_t docNumber)=0

Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector contains terms and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null. The term vectors that are returned may either be of type TermFreqVector or of type TermPositionVector if positions or offsets have been stored. More...

virtual TermFreqVectorPtr | getTermFreqVector (int32_t docNumber, const String &field)=0
| Return a term frequency vector for the specified document and field. The returned vector contains terms and frequencies for the terms in the specified field of this document, if the field had the storeTermVector flag set. If termvectors had been stored with positions or offsets, a TermPositionVector is returned. More...
virtual void | getTermFreqVector (int32_t docNumber, const String &field, const TermVectorMapperPtr &mapper)=0
| Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the TermFreqVector. More...
virtual void | getTermFreqVector (int32_t docNumber, const TermVectorMapperPtr &mapper)=0
| Map all the term vectors for all fields in a Document. More...
virtual int32_t | numDocs ()=0
| Returns the number of documents in this index. More...
virtual int32_t | maxDoc ()=0
| Returns one greater than the largest possible document number. This may be used to, eg., determine how big to allocate an array which will have an element for every document number in an index. More...
int32_t | numDeletedDocs ()
| Returns the number of deleted documents. More...
virtual DocumentPtr | document (int32_t n)
| Returns the stored fields of the n'th Document in this index. More...
virtual DocumentPtr | document (int32_t n, const FieldSelectorPtr &fieldSelector)=0

Get the Document at the n'th position. The FieldSelector may be used to determine what Fields to load and how they should be loaded. NOTE: If this Reader (more specifically, the underlying FieldsReader) is closed before the lazy Field is loaded an exception may be thrown. If you want the value of a lazy Field to be available after closing you must explicitly load it or fetch the Document again with a new loader. More...

virtual bool | isDeleted (int32_t n)=0
| Returns true if document n has been deleted. More...
virtual bool | hasDeletions ()=0
| Returns true if any documents have been deleted. More...
virtual bool | hasChanges ()
| Used for testing. More...
virtual bool | hasNorms (const String &field)
| Returns true if there are norms stored for this field. More...
virtual ByteArray | norms (const String &field)=0
| Returns the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents. More...
virtual void | norms (const String &field, ByteArray norms, int32_t offset)=0
| Reads the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents. More...
virtual void | setNorm (int32_t doc, const String &field, uint8_t value)
| Resets the normalization factor for the named field of the named document. The norm represents the product of the field's boost and its length normalization. Thus, to preserve the length normalization values when resetting this, one should base the new value upon the old. More...
virtual void | setNorm (int32_t doc, const String &field, double value)
| Resets the normalization factor for the named field of the named document. More...
virtual TermEnumPtr | terms ()=0
| Returns an enumeration of all the terms in the index. The enumeration is ordered by Term::compareTo(). Each term is greater than all that precede it in the enumeration. Note that after calling terms(), TermEnum#next() must be called on the resulting enumeration before calling other methods such as TermEnum#term(). More...
virtual TermEnumPtr | terms (const TermPtr &t)=0
| Returns an enumeration of all terms starting at a given term. If the given term does not exist, the enumeration is positioned at the first term greater than the supplied term. The enumeration is ordered by Term::compareTo(). Each term is greater than all that precede it in the enumeration. More...
virtual int32_t | docFreq (const TermPtr &t)=0
| Returns the number of documents containing the term t. More...
virtual TermDocsPtr | termDocs (const TermPtr &term)
| Returns an enumeration of all the documents which contain term. For each document, the document number, the frequency of the term in that document is also provided, for use in search scoring. If term is null, then all non-deleted docs are returned with freq=1. The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration. More...
virtual TermDocsPtr | termDocs ()=0
| Returns an unpositioned TermDocs enumerator. More...
virtual TermPositionsPtr | termPositions (const TermPtr &term)

Returns an enumeration of all the documents which contain term. For each document, in addition to the document number and frequency of the term in that document, a list of all of the ordinal positions of the term in the document is available. Thus, this method positions of the term in the document is available. This positional information facilitates phrase and proximity searching. The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration. More...

virtual TermPositionsPtr | termPositions ()=0
| Returns an unpositioned TermPositions enumerator. More...
virtual void | deleteDocument (int32_t docNum)
| Deletes the document numbered docNum. Once a document is deleted it will not appear in TermDocs or TermPostitions enumerations. Attempts to read its field with the document method will result in an error. The presence of this document may still be reflected in the docFreq statistic, though this will be corrected eventually as the index is further modified. More...
virtual int32_t | deleteDocuments (const TermPtr &term)
| Deletes all documents that have a given term indexed. This is useful if one uses a document field to hold a unique ID string for the document. Then to delete such a document, one merely constructs a term with the appropriate field and the unique ID string as its text and passes it to this method. See deleteDocument(int) for information about when this deletion will become effective. More...
virtual void | undeleteAll ()
| Undeletes all documents currently marked as deleted in this index. More...
void | flush ()
void | flush (MapStringString commitUserData)
void | commit (MapStringString commitUserData)
| Commit changes resulting from delete, undeleteAll, or setNorm operations. If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics). More...
void | close ()
| Closes files associated with this index. Also saves any new deletions to disk. No other methods should be called after this has been called. More...
virtual HashSet< String > | getFieldNames (FieldOption fieldOption)=0
| Get a list of unique field names that exist in this index and have the specified field option information. More...
virtual IndexCommitPtr | getIndexCommit ()
| Return the IndexCommit that this reader has opened. This method is only implemented by those readers that correspond to a Directory with its own segments_N file. More...
virtual Collection< IndexReaderPtr > | getSequentialSubReaders ()
| Returns the sequential sub readers that this reader is logically composed of. For example, IndexSearcher uses this API to drive searching by one sub reader at a time. If this reader is not composed of sequential child readers, it should return null. If this method returns an empty array, that means this reader is a null reader (for example a MultiReader that has no sub readers). More...
virtual LuceneObjectPtr | getFieldCacheKey ()
virtual LuceneObjectPtr | getDeletesCacheKey ()
| This returns null if the reader has no deletions. More...
virtual int64_t | getUniqueTermCount ()
| Returns the number of unique terms (across all fields) in this reader. More...
virtual int32_t | getTermInfosIndexDivisor ()
| For IndexReader implementations that use TermInfosReader to read terms, this returns the current indexDivisor as specified when the reader was opened. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
static IndexReaderPtr | open (const DirectoryPtr &directory)
| Returns a IndexReader reading the index in the given Directory, with readOnly = true. More...
static IndexReaderPtr | open (const DirectoryPtr &directory, bool readOnly)
| Returns an IndexReader reading the index in the given Directory. You should pass readOnly = true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const IndexCommitPtr &commit, bool readOnly)
| Returns an IndexReader reading the index in the given IndexCommit. You should pass readOnly = true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const DirectoryPtr &directory, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly)
| Returns an IndexReader reading the index in the given Directory, with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const DirectoryPtr &directory, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly, int32_t termInfosIndexDivisor)
| Returns an IndexReader reading the index in the given Directory, with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const IndexCommitPtr &commit, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly)
| Returns an IndexReader reading the index in the given Directory, using a specific commit and with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const IndexCommitPtr &commit, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly, int32_t termInfosIndexDivisor)
| Returns an IndexReader reading the index in the given Directory, using a specific commit and with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static int64_t | lastModified (const DirectoryPtr &directory2)
| Returns the time the index in the named directory was last modified. Do not use this to check whether the reader is still up-to-date, use isCurrent() instead. More...
static int64_t | getCurrentVersion (const DirectoryPtr &directory)
| Reads version number from segments files. The version number is initialized with a timestamp and then increased by one for each change of the index. More...
static MapStringString | getCommitUserData (const DirectoryPtr &directory)
| Reads commitUserData, previously passed to IndexWriter#commit(MapStringString), from current index segments file. This will return null if IndexWriter#commit(MapStringString) has never been called for this index. More...
static bool | indexExists (const DirectoryPtr &directory)
| Returns true if an index exists at the specified directory. If the directory does not exist or if there is no index in it. More...
static void | main (Collection< String > args)
| Prints the filename and size of each file within a given compound file. Add the -extract flag to extract files to the current working directory. In order to make the extracted version of the index work, you have to copy the segments file from the compound index into the directory where the extracted files are stored. More...
static Collection< IndexCommitPtr > | listCommits (const DirectoryPtr &dir)

Returns all commit points that exist in the Directory. Normally, because the default is KeepOnlyLastCommitDeletionPolicy, there would be only one commit point. But if you're using a custom IndexDeletionPolicy then there could be many commits. Once you have a given commit, you can open a reader on it by calling IndexReader#open(IndexCommit,bool). There must be at least one commit in the Directory, else this method throws an exception. Note that if a commit is in progress while this method is running, that commit may or may not be returned array. More...

## Static Public Attributes

static const int32_t | DEFAULT_TERMS_INDEX_DIVISOR

## Protected Member Functions

void | ensureOpen ()
virtual void | doSetNorm (int32_t doc, const String &field, uint8_t value)=0
| Implements setNorm in subclass. More...
virtual void | doDelete (int32_t docNum)=0
| Implements deletion of the document numbered docNum. Applications should call deleteDocument(int) or deleteDocuments(Term). More...
virtual void | doUndeleteAll ()=0
| Implements actual undeleteAll() in subclass. More...
virtual void | acquireWriteLock ()
| Does nothing by default. Subclasses that require a write lock for index modifications must implement this method. More...
void | commit ()
| Commit changes resulting from delete, undeleteAll, or setNorm operations. If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics). More...
virtual void | doCommit (MapStringString commitUserData)=0
| Implements commit. More...
virtual void | doClose ()=0
| Implements close. More...
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Static Protected Member Functions

static IndexReaderPtr | open (const DirectoryPtr &directory, const IndexDeletionPolicyPtr &deletionPolicy, const IndexCommitPtr &commit, bool readOnly, int32_t termInfosIndexDivisor)

## Protected Attributes

bool | closed
bool | _hasChanges
int32_t | refCount
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

IndexReader is an abstract class, providing an interface for accessing an index. Search of an index is done entirely through this abstract interface, so that any subclass which implements it is searchable.

Concrete subclasses of IndexReader are usually constructed with a call to one of the static open methods, eg. open(DirectoryPtr, bool).

For efficiency, in this API documents are often referred to via document numbers, non-negative integers which each name a unique document in the index. These document numbers are ephemeral -they may change as documents are added to and deleted from an index. Clients should thus not rely on a given document having the same number between sessions.

An IndexReader can be opened on a directory for which an IndexWriter is opened already, but it cannot be used to delete documents from the index then.

NOTE: for backwards API compatibility, several methods are not listed as abstract, but have no useful implementations in this base class and instead always throw UnsupportedOperation exception. Subclasses are strongly encouraged to override these methods, but in many cases may not need to.

NOTE: as of 2.4, it's possible to open a read-only IndexReader using the static open methods that accept the bool readOnly parameter. Such a reader has better concurrency as it's not necessary to synchronize on the isDeleted method. You must specify false if you want to make changes with the resulting IndexReader.

NOTE: IndexReader instances are completely thread safe, meaning multiple threads can call any of its methods, concurrently. If your application requires external synchronization, you should not synchronize on the IndexReader instance; use your own (non-Lucene) objects instead.

## Member Enumeration Documentation

enum Lucene::IndexReader::FieldOption

Constants describing field properties, for example used for IndexReader#getFieldNames(FieldOption).

Enumerator
FIELD_OPTION_ALL | All fields.
FIELD_OPTION_INDEXED | All indexed fields.
FIELD_OPTION_STORES_PAYLOADS | All fields that store payloads.
FIELD_OPTION_OMIT_TERM_FREQ_AND_POSITIONS | All fields that omit tf.
FIELD_OPTION_UNINDEXED | All fields which are not indexed.
FIELD_OPTION_INDEXED_WITH_TERMVECTOR | All fields which are indexed with termvectors enabled.
FIELD_OPTION_INDEXED_NO_TERMVECTOR | All fields which are indexed but don't have termvectors enabled.
FIELD_OPTION_TERMVECTOR | All fields with termvectors enabled. Please note that only standard termvector fields are returned.
FIELD_OPTION_TERMVECTOR_WITH_POSITION | All fields with termvectors with position values enabled.
FIELD_OPTION_TERMVECTOR_WITH_OFFSET | All fields with termvectors with offset values enabled.
FIELD_OPTION_TERMVECTOR_WITH_POSITION_OFFSET | All fields with termvectors with offset values and position values enabled.

## Constructor & Destructor Documentation

Lucene::IndexReader::IndexReader | ( |  | ) |

virtual Lucene::IndexReader::~IndexReader | ( |  | ) |

virtual

## Member Function Documentation

static String Lucene::IndexReader::_getClassName | ( |  | ) |

inline static

virtual void Lucene::IndexReader::acquireWriteLock | ( |  | ) |

protected virtual

Does nothing by default. Subclasses that require a write lock for index modifications must implement this method.

Reimplemented in Lucene::DirectoryReader, Lucene::ReadOnlyDirectoryReader, and Lucene::ReadOnlySegmentReader.

virtual LuceneObjectPtr Lucene::IndexReader::clone | ( | const LuceneObjectPtr & | other = `LuceneObjectPtr()` | ) |

virtual

Efficiently clones the IndexReader (sharing most internal state).

On cloning a reader with pending changes (deletions, norms), the original reader transfers its write lock to the cloned reader. This means only the cloned reader may make further changes to the index, and commit the changes to the index on close, but the old reader still reflects all changes made up until it was cloned.

Like reopen(), it's safe to make changes to either the original or the cloned reader: all shared mutable state obeys "copy on write" semantics to ensure the changes are not seen by other readers.

Reimplemented from Lucene::LuceneObject.

Reimplemented in Lucene::SegmentReader, Lucene::DirectoryReader, Lucene::ParallelReader, and Lucene::MultiReader.

virtual LuceneObjectPtr Lucene::IndexReader::clone | ( | bool | openReadOnly,
|  | const LuceneObjectPtr & | other = `LuceneObjectPtr()`
| ) |  |

virtual

Clones the IndexReader and optionally changes readOnly. A readOnly reader cannot open a writable reader.

Reimplemented in Lucene::SegmentReader, and Lucene::DirectoryReader.

void Lucene::IndexReader::close | ( |  | ) |

Closes files associated with this index. Also saves any new deletions to disk. No other methods should be called after this has been called.

void Lucene::IndexReader::commit | ( | MapStringString | commitUserData | ) |

Commit changes resulting from delete, undeleteAll, or setNorm operations. If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics).

void Lucene::IndexReader::commit | ( |  | ) |

protected

Commit changes resulting from delete, undeleteAll, or setNorm operations. If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics).

void Lucene::IndexReader::decRef | ( |  | ) |

Decreases the refCount of this IndexReader instance. If the refCount drops to 0, then pending changes (if any) are committed to the index and this reader is closed.

See also
  incRef

virtual void Lucene::IndexReader::deleteDocument | ( | int32_t | docNum | ) |

virtual

Deletes the document numbered docNum. Once a document is deleted it will not appear in TermDocs or TermPostitions enumerations. Attempts to read its field with the document method will result in an error. The presence of this document may still be reflected in the docFreq statistic, though this will be corrected eventually as the index is further modified.

virtual int32_t Lucene::IndexReader::deleteDocuments | ( | const TermPtr & | term | ) |

virtual

Deletes all documents that have a given term indexed. This is useful if one uses a document field to hold a unique ID string for the document. Then to delete such a document, one merely constructs a term with the appropriate field and the unique ID string as its text and passes it to this method. See deleteDocument(int) for information about when this deletion will become effective.

Returns
  the number of documents deleted

virtual DirectoryPtr Lucene::IndexReader::directory | ( |  | ) |

virtual

Returns the directory associated with this index. The default implementation returns the directory specified by subclasses when delegating to the IndexReader(Directory) constructor, or throws an UnsupportedOperation exception if one was not specified.

Reimplemented in Lucene::SegmentReader, Lucene::DirectoryReader, and Lucene::FilterIndexReader.

virtual int32_t Lucene::IndexReader::docFreq | ( | const TermPtr & | t | ) |

pure virtual

Returns the number of documents containing the term t.

Implemented in Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::SegmentReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual void Lucene::IndexReader::doClose | ( |  | ) |

protected pure virtual

Implements close.

Implemented in Lucene::SegmentReader, Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual void Lucene::IndexReader::doCommit | ( | MapStringString | commitUserData | ) |

protected pure virtual

Implements commit.

Implemented in Lucene::SegmentReader, Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual DocumentPtr Lucene::IndexReader::document | ( | int32_t | n | ) |

virtual

Returns the stored fields of the n'th Document in this index.

NOTE: for performance reasons, this method does not check if the requested document is deleted, and therefore asking for a deleted document may yield unspecified results. Usually this is not required, however you can call isDeleted(int) with the requested document ID to verify the document is not deleted.

virtual DocumentPtr Lucene::IndexReader::document | ( | int32_t | n,
|  | const FieldSelectorPtr & | fieldSelector
| ) |  |

pure virtual

Get the Document at the n'th position. The FieldSelector may be used to determine what Fields to load and how they should be loaded. NOTE: If this Reader (more specifically, the underlying FieldsReader) is closed before the lazy Field is loaded an exception may be thrown. If you want the value of a lazy Field to be available after closing you must explicitly load it or fetch the Document again with a new loader.

NOTE: for performance reasons, this method does not check if the requested document is deleted, and therefore asking for a deleted document may yield unspecified results. Usually this is not required, however you can call isDeleted(int32_t) with the requested document ID to verify the document is not deleted.

Parameters

  n | Get the document at the n'th position
  fieldSelector | The FieldSelector to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.

Returns
  The stored fields of the Document at the n'th position

See also
  Fieldable
  FieldSelector
  SetBasedFieldSelector
  LoadFirstFieldSelector

Implemented in Lucene::DirectoryReader, Lucene::SegmentReader, Lucene::ParallelReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual void Lucene::IndexReader::doDelete | ( | int32_t | docNum | ) |

protected pure virtual

Implements deletion of the document numbered docNum. Applications should call deleteDocument(int) or deleteDocuments(Term).

Implemented in Lucene::SegmentReader, Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual void Lucene::IndexReader::doSetNorm | ( | int32_t | doc,
|  | const String & | field,
|  | uint8_t | value
| ) |  |

protected pure virtual

Implements setNorm in subclass.

Implemented in Lucene::SegmentReader, Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual void Lucene::IndexReader::doUndeleteAll | ( |  | ) |

protected pure virtual

Implements actual undeleteAll() in subclass.

Implemented in Lucene::SegmentReader, Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

void Lucene::IndexReader::ensureOpen | ( |  | ) |

protected

void Lucene::IndexReader::flush | ( |  | ) |

void Lucene::IndexReader::flush | ( | MapStringString | commitUserData | ) |

Parameters

  commitUserData | Opaque Map (String -> String) that's recorded into the segments file in the index, and retrievable by IndexReader#getCommitUserData.

virtual String Lucene::IndexReader::getClassName | ( |  | ) |

inline virtual

Reimplemented in Lucene::ParallelReader, Lucene::DirectoryReader, Lucene::FilterIndexReader, Lucene::MultiReader, Lucene::ReadOnlyDirectoryReader, Lucene::SegmentReader, and Lucene::ReadOnlySegmentReader.

static MapStringString Lucene::IndexReader::getCommitUserData | ( | const DirectoryPtr & | directory | ) |

static

Reads commitUserData, previously passed to IndexWriter#commit(MapStringString), from current index segments file. This will return null if IndexWriter#commit(MapStringString) has never been called for this index.

virtual MapStringString Lucene::IndexReader::getCommitUserData | ( |  | ) |

virtual

Retrieve the String userData optionally passed to IndexWriter::commit. This will return null if IndexWriter#commit(MapStringString) has never been called for this index.

Reimplemented in Lucene::DirectoryReader.

static int64_t Lucene::IndexReader::getCurrentVersion | ( | const DirectoryPtr & | directory | ) |

static

Reads version number from segments files. The version number is initialized with a timestamp and then increased by one for each change of the index.

Parameters

  directory | where the index resides.

Returns
  version number.

virtual LuceneObjectPtr Lucene::IndexReader::getDeletesCacheKey | ( |  | ) |

virtual

This returns null if the reader has no deletions.

Reimplemented in Lucene::SegmentReader, and Lucene::FilterIndexReader.

virtual LuceneObjectPtr Lucene::IndexReader::getFieldCacheKey | ( |  | ) |

virtual

Reimplemented in Lucene::SegmentReader, and Lucene::FilterIndexReader.

virtual HashSet<String> Lucene::IndexReader::getFieldNames | ( | FieldOption | fieldOption | ) |

pure virtual

Get a list of unique field names that exist in this index and have the specified field option information.

Parameters

  fieldOption | specifies which field option should be available for the returned fields

Returns
  Collection of Strings indicating the names of the fields.

Implemented in Lucene::ParallelReader, Lucene::DirectoryReader, Lucene::SegmentReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual IndexCommitPtr Lucene::IndexReader::getIndexCommit | ( |  | ) |

virtual

Return the IndexCommit that this reader has opened. This method is only implemented by those readers that correspond to a Directory with its own segments_N file.

Reimplemented in Lucene::DirectoryReader.

int32_t Lucene::IndexReader::getRefCount | ( |  | ) |

Returns the current refCount for this reader.

virtual Collection<IndexReaderPtr> Lucene::IndexReader::getSequentialSubReaders | ( |  | ) |

virtual

Returns the sequential sub readers that this reader is logically composed of. For example, IndexSearcher uses this API to drive searching by one sub reader at a time. If this reader is not composed of sequential child readers, it should return null. If this method returns an empty array, that means this reader is a null reader (for example a MultiReader that has no sub readers).

NOTE: You should not try using sub-readers returned by this method to make any changes (setNorm, deleteDocument, etc.). While this might succeed for one composite reader (like MultiReader), it will most likely lead to index corruption for other readers (like DirectoryReader obtained through open. Use the parent reader directly.

Reimplemented in Lucene::DirectoryReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual TermFreqVectorPtr Lucene::IndexReader::getTermFreqVector | ( | int32_t | docNumber,
|  | const String & | field
| ) |  |

pure virtual

Return a term frequency vector for the specified document and field. The returned vector contains terms and frequencies for the terms in the specified field of this document, if the field had the storeTermVector flag set. If termvectors had been stored with positions or offsets, a TermPositionVector is returned.

Parameters

  docNumber | document for which the term frequency vector is returned.
  field | field for which the term frequency vector is returned.

Returns
  term frequency vector May be null if field does not exist in the specified document or term vector was not stored.

Implemented in Lucene::SegmentReader, Lucene::ParallelReader, Lucene::DirectoryReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual void Lucene::IndexReader::getTermFreqVector | ( | int32_t | docNumber,
|  | const String & | field,
|  | const TermVectorMapperPtr & | mapper
| ) |  |

pure virtual

Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the TermFreqVector.

Parameters

  docNumber | The number of the document to load the vector for
  field | The name of the field to load
  mapper | The TermVectorMapper to process the vector. Must not be null.

Implemented in Lucene::SegmentReader, Lucene::ParallelReader, Lucene::DirectoryReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual void Lucene::IndexReader::getTermFreqVector | ( | int32_t | docNumber,
|  | const TermVectorMapperPtr & | mapper
| ) |  |

pure virtual

Map all the term vectors for all fields in a Document.

Parameters

  docNumber | The number of the document to load the vector for
  mapper | The TermVectorMapper to process the vector. Must not be null.

Implemented in Lucene::SegmentReader, Lucene::ParallelReader, Lucene::DirectoryReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual Collection<TermFreqVectorPtr> Lucene::IndexReader::getTermFreqVectors | ( | int32_t | docNumber | ) |

pure virtual

Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector contains terms and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null. The term vectors that are returned may either be of type TermFreqVector or of type TermPositionVector if positions or offsets have been stored.

Parameters

  docNumber | document for which term frequency vectors are returned

Returns
  array of term frequency vectors. May be null if no term vectors have been stored for the specified document.

Implemented in Lucene::SegmentReader, Lucene::ParallelReader, Lucene::DirectoryReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual int32_t Lucene::IndexReader::getTermInfosIndexDivisor | ( |  | ) |

virtual

For IndexReader implementations that use TermInfosReader to read terms, this returns the current indexDivisor as specified when the reader was opened.

Reimplemented in Lucene::SegmentReader, and Lucene::DirectoryReader.

virtual int64_t Lucene::IndexReader::getUniqueTermCount | ( |  | ) |

virtual

Returns the number of unique terms (across all fields) in this reader.

This method returns int64_t, even though internally Lucene cannot handle more than 2^31 unique terms, for a possible future when this limitation is removed.

Reimplemented in Lucene::SegmentReader.

virtual int64_t Lucene::IndexReader::getVersion | ( |  | ) |

virtual

Version number when this IndexReader was opened. Not implemented in the IndexReader base class.

If this reader is based on a Directory (ie, was created by calling open, or reopen on a reader based on a Directory), then this method returns the version recorded in the commit that the reader opened. This version is advanced every time IndexWriter#commit is called.

If instead this reader is a near real-time reader (ie, obtained by a call to IndexWriter#getReader, or by calling reopen on a near real-time reader), then this method returns the version of the last commit done by the writer. Note that even as further changes are made with the writer, the version will not changed until a commit is completed. Thus, you should not rely on this method to determine when a near real-time reader should be opened. Use isCurrent instead.

Reimplemented in Lucene::ParallelReader, Lucene::MultiReader, Lucene::DirectoryReader, and Lucene::FilterIndexReader.

virtual bool Lucene::IndexReader::hasChanges | ( |  | ) |

virtual

Used for testing.

virtual bool Lucene::IndexReader::hasDeletions | ( |  | ) |

pure virtual

Returns true if any documents have been deleted.

Implemented in Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, Lucene::SegmentReader, and Lucene::FilterIndexReader.

virtual bool Lucene::IndexReader::hasNorms | ( | const String & | field | ) |

virtual

Returns true if there are norms stored for this field.

Reimplemented in Lucene::SegmentReader, Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

void Lucene::IndexReader::incRef | ( |  | ) |

Increments the refCount of this IndexReader instance. RefCounts are used to determine when a reader can be closed safely, i.e. as soon as there are no more references. Be sure to always call a corresponding decRef, in a finally clause; otherwise the reader may never be closed. Note that close simply calls decRef(), which means that the IndexReader will not really be closed until decRef has been called for all outstanding references.

See also
  decRef

static bool Lucene::IndexReader::indexExists | ( | const DirectoryPtr & | directory | ) |

static

Returns true if an index exists at the specified directory. If the directory does not exist or if there is no index in it.

Parameters

  directory | the directory to check for an index

Returns
  true if an index exists; false otherwise

virtual bool Lucene::IndexReader::isCurrent | ( |  | ) |

virtual

Check whether any new changes have occurred to the index since this reader was opened.

If this reader is based on a Directory (ie, was created by calling open, or reopen on a reader based on a Directory), then this method checks if any further commits (see IndexWriter#commit have occurred in that directory).

If instead this reader is a near real-time reader (ie, obtained by a call to IndexWriter#getReader, or by calling reopen on a near real-time reader), then this method checks if either a new commit has occurred, or any new uncommitted changes have taken place via the writer. Note that even if the writer has only performed merging, this method will still return false.

In any event, if this returns false, you should call reopen to get a new reader that sees the changes.

Reimplemented in Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual bool Lucene::IndexReader::isDeleted | ( | int32_t | n | ) |

pure virtual

Returns true if document n has been deleted.

Implemented in Lucene::DirectoryReader, Lucene::SegmentReader, Lucene::ParallelReader, Lucene::MultiReader, Lucene::FilterIndexReader, and Lucene::ReadOnlySegmentReader.

virtual bool Lucene::IndexReader::isOptimized | ( |  | ) |

virtual

Checks is the index is optimized (if it has a single segment and no deletions). Not implemented in the IndexReader base class.

Returns
  true if the index is optimized; false otherwise

Reimplemented in Lucene::ParallelReader, Lucene::DirectoryReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

static int64_t Lucene::IndexReader::lastModified | ( | const DirectoryPtr & | directory2 | ) |

static

Returns the time the index in the named directory was last modified. Do not use this to check whether the reader is still up-to-date, use isCurrent() instead.

static Collection<IndexCommitPtr> Lucene::IndexReader::listCommits | ( | const DirectoryPtr & | dir | ) |

static

Returns all commit points that exist in the Directory. Normally, because the default is KeepOnlyLastCommitDeletionPolicy, there would be only one commit point. But if you're using a custom IndexDeletionPolicy then there could be many commits. Once you have a given commit, you can open a reader on it by calling IndexReader#open(IndexCommit,bool). There must be at least one commit in the Directory, else this method throws an exception. Note that if a commit is in progress while this method is running, that commit may or may not be returned array.

static void Lucene::IndexReader::main | ( | Collection< String > | args | ) |

static

Prints the filename and size of each file within a given compound file. Add the -extract flag to extract files to the current working directory. In order to make the extracted version of the index work, you have to copy the segments file from the compound index into the directory where the extracted files are stored.

Parameters

  args | Usage: IndexReader [-extract] <cfsfile>

virtual int32_t Lucene::IndexReader::maxDoc | ( |  | ) |

pure virtual

Returns one greater than the largest possible document number. This may be used to, eg., determine how big to allocate an array which will have an element for every document number in an index.

Implemented in Lucene::SegmentReader, Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual ByteArray Lucene::IndexReader::norms | ( | const String & | field | ) |

pure virtual

Returns the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.

See also
  Field::setBoost(double)

Implemented in Lucene::SegmentReader, Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual void Lucene::IndexReader::norms | ( | const String & | field,
|  | ByteArray | norms,
|  | int32_t | offset
| ) |  |

pure virtual

Reads the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.

See also
  Field::setBoost(double)

Implemented in Lucene::SegmentReader, Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

int32_t Lucene::IndexReader::numDeletedDocs | ( |  | ) |

Returns the number of deleted documents.

virtual int32_t Lucene::IndexReader::numDocs | ( |  | ) |

pure virtual

Returns the number of documents in this index.

Implemented in Lucene::SegmentReader, Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

static IndexReaderPtr Lucene::IndexReader::open | ( | const DirectoryPtr & | directory | ) |

static

Returns a IndexReader reading the index in the given Directory, with readOnly = true.

Parameters

  directory | the index directory

static IndexReaderPtr Lucene::IndexReader::open | ( | const DirectoryPtr & | directory,
|  | bool | readOnly
| ) |  |

static

Returns an IndexReader reading the index in the given Directory. You should pass readOnly = true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader.

Parameters

  directory | the index directory
  readOnly | true if no changes (deletions, norms) will be made with this IndexReader

static IndexReaderPtr Lucene::IndexReader::open | ( | const IndexCommitPtr & | commit,
|  | bool | readOnly
| ) |  |

static

Returns an IndexReader reading the index in the given IndexCommit. You should pass readOnly = true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader.

Parameters

  commit | the commit point to open
  readOnly | true if no changes (deletions, norms) will be made with this IndexReader

static IndexReaderPtr Lucene::IndexReader::open | ( | const DirectoryPtr & | directory,
|  | const IndexDeletionPolicyPtr & | deletionPolicy,
|  | bool | readOnly
| ) |  |

static

Returns an IndexReader reading the index in the given Directory, with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader.

Parameters

  directory | the index directory
  deletionPolicy | a custom deletion policy (only used if you use this reader to perform deletes or to set norms); see IndexWriter for details.
  readOnly | true if no changes (deletions, norms) will be made with this IndexReader

static IndexReaderPtr Lucene::IndexReader::open | ( | const DirectoryPtr & | directory,
|  | const IndexDeletionPolicyPtr & | deletionPolicy,
|  | bool | readOnly,
|  | int32_t | termInfosIndexDivisor
| ) |  |

static

Returns an IndexReader reading the index in the given Directory, with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader.

Parameters

  directory | the index directory
  deletionPolicy | a custom deletion policy (only used if you use this reader to perform deletes or to set norms); see IndexWriter for details.
  readOnly | true if no changes (deletions, norms) will be made with this IndexReader

  termInfosIndexDivisor

  Subsamples which indexed terms are loaded into RAM. This has the same effect as IndexWriter#setTermIndexInterval except that setting must be done at indexing time while this setting can be set per reader. When set to N, then one in every N*termIndexInterval terms in the index is loaded into memory. By setting this to a value > 1 you can reduce memory usage, at the expense of higher latency when loading a TermInfo. The default value is 1. Set this to -1 to skip loading the terms index entirely.

static IndexReaderPtr Lucene::IndexReader::open | ( | const IndexCommitPtr & | commit,
|  | const IndexDeletionPolicyPtr & | deletionPolicy,
|  | bool | readOnly
| ) |  |

static

Returns an IndexReader reading the index in the given Directory, using a specific commit and with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader.

Parameters

  commit | the specific IndexCommit to open; see IndexReader#listCommits to list all commits in a directory
  deletionPolicy | a custom deletion policy (only used if you use this reader to perform deletes or to set norms); see IndexWriter for details.
  readOnly | true if no changes (deletions, norms) will be made with this IndexReader

static IndexReaderPtr Lucene::IndexReader::open | ( | const IndexCommitPtr & | commit,
|  | const IndexDeletionPolicyPtr & | deletionPolicy,
|  | bool | readOnly,
|  | int32_t | termInfosIndexDivisor
| ) |  |

static

Returns an IndexReader reading the index in the given Directory, using a specific commit and with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader.

Parameters

  commit | the specific IndexCommit to open; see IndexReader#listCommits to list all commits in a directory
  deletionPolicy | a custom deletion policy (only used if you use this reader to perform deletes or to set norms); see IndexWriter for details.
  readOnly | true if no changes (deletions, norms) will be made with this IndexReader

  termInfosIndexDivisor

  Subsamples which indexed terms are loaded into RAM. This has the same effect as IndexWriter#setTermIndexInterval except that setting must be done at indexing time while this setting can be set per reader. When set to N, then one in every N * termIndexInterval terms in the index is loaded into memory. By setting this to a value > 1 you can reduce memory usage, at the expense of higher latency when loading a TermInfo. The default value is 1. Set this to -1 to skip loading the terms index entirely.

static IndexReaderPtr Lucene::IndexReader::open | ( | const DirectoryPtr & | directory,
|  | const IndexDeletionPolicyPtr & | deletionPolicy,
|  | const IndexCommitPtr & | commit,
|  | bool | readOnly,
|  | int32_t | termInfosIndexDivisor
| ) |  |

static protected

virtual IndexReaderPtr Lucene::IndexReader::reopen | ( |  | ) |

virtual

Refreshes an IndexReader if the index has changed since this instance was (re)opened.

Opening an IndexReader is an expensive operation. This method can be used to refresh an existing IndexReader to reduce these costs. This method tries to only load segments that have changed or were created after the IndexReader was (re)opened.

If the index has not changed since this instance was (re)opened, then this call is a NOOP and returns this instance. Otherwise, a new instance is returned. The old instance is not closed and remains usable.

If the reader is reopened, even though they share resources internally, it's safe to make changes (deletions, norms) with the new reader. All shared mutable state obeys "copy on write" semantics to ensure the changes are not seen by other readers.

You can determine whether a reader was actually reopened by comparing the old instance with the instance returned by this method:

    IndexReaderPtr reader = ...
    ...
    IndexReaderPtr newReader = r.reopen();
    if (newReader != reader)
    {
        ... // reader was reopened
        reader->close();
    }
    reader = newReader;
    ...

Be sure to synchronize that code so that other threads, if present, can never use reader after it has been closed and before it's switched to newReader. If this reader is a near real-time reader (obtained from IndexWriter#getReader(), reopen() will simply call writer.getReader() again for you, though this may change in the future.

Reimplemented in Lucene::ParallelReader, Lucene::DirectoryReader, and Lucene::MultiReader.

virtual IndexReaderPtr Lucene::IndexReader::reopen | ( | bool | openReadOnly | ) |

virtual

Just like reopen(), except you can change the readOnly of the original reader. If the index is unchanged but readOnly is different then a new reader will be returned.

Reimplemented in Lucene::DirectoryReader.

virtual IndexReaderPtr Lucene::IndexReader::reopen | ( | const IndexCommitPtr & | commit | ) |

virtual

Reopen this reader on a specific commit point. This always returns a readOnly reader. If the specified commit point matches what this reader is already on, and this reader is already readOnly, then this same instance is returned; if it is not already readOnly, a readOnly clone is returned.

Reimplemented in Lucene::DirectoryReader.

virtual void Lucene::IndexReader::setNorm | ( | int32_t | doc,
|  | const String & | field,
|  | uint8_t | value
| ) |  |

virtual

Resets the normalization factor for the named field of the named document. The norm represents the product of the field's boost and its length normalization. Thus, to preserve the length normalization values when resetting this, one should base the new value upon the old.

NOTE: If this field does not store norms, then this method call will silently do nothing.

See also
  #norms(String)
  Similarity::decodeNorm(byte)

virtual void Lucene::IndexReader::setNorm | ( | int32_t | doc,
|  | const String & | field,
|  | double | value
| ) |  |

virtual

Resets the normalization factor for the named field of the named document.

See also
  #norms(String)
  Similarity::decodeNorm(byte)

boost::shared_ptr< IndexReader > Lucene::IndexReader::shared_from_this | ( |  | ) |

inline

virtual TermDocsPtr Lucene::IndexReader::termDocs | ( | const TermPtr & | term | ) |

virtual

Returns an enumeration of all the documents which contain term. For each document, the document number, the frequency of the term in that document is also provided, for use in search scoring. If term is null, then all non-deleted docs are returned with freq=1. The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration.

Reimplemented in Lucene::ParallelReader, Lucene::SegmentReader, and Lucene::FilterIndexReader.

virtual TermDocsPtr Lucene::IndexReader::termDocs | ( |  | ) |

pure virtual

Returns an unpositioned TermDocs enumerator.

Implemented in Lucene::ParallelReader, Lucene::DirectoryReader, Lucene::SegmentReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual TermPositionsPtr Lucene::IndexReader::termPositions | ( | const TermPtr & | term | ) |

virtual

Returns an enumeration of all the documents which contain term. For each document, in addition to the document number and frequency of the term in that document, a list of all of the ordinal positions of the term in the document is available. Thus, this method positions of the term in the document is available. This positional information facilitates phrase and proximity searching. The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration.

Reimplemented in Lucene::ParallelReader.

virtual TermPositionsPtr Lucene::IndexReader::termPositions | ( |  | ) |

pure virtual

Returns an unpositioned TermPositions enumerator.

Implemented in Lucene::ParallelReader, Lucene::DirectoryReader, Lucene::SegmentReader, Lucene::MultiReader, and Lucene::FilterIndexReader.

virtual TermEnumPtr Lucene::IndexReader::terms | ( |  | ) |

pure virtual

Returns an enumeration of all the terms in the index. The enumeration is ordered by Term::compareTo(). Each term is greater than all that precede it in the enumeration. Note that after calling terms(), TermEnum#next() must be called on the resulting enumeration before calling other methods such as TermEnum#term().

Implemented in Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, Lucene::SegmentReader, and Lucene::FilterIndexReader.

virtual TermEnumPtr Lucene::IndexReader::terms | ( | const TermPtr & | t | ) |

pure virtual

Returns an enumeration of all terms starting at a given term. If the given term does not exist, the enumeration is positioned at the first term greater than the supplied term. The enumeration is ordered by Term::compareTo(). Each term is greater than all that precede it in the enumeration.

Implemented in Lucene::DirectoryReader, Lucene::ParallelReader, Lucene::MultiReader, Lucene::SegmentReader, and Lucene::FilterIndexReader.

virtual void Lucene::IndexReader::undeleteAll | ( |  | ) |

virtual

Undeletes all documents currently marked as deleted in this index.

## Field Documentation

bool Lucene::IndexReader::_hasChanges

protected

bool Lucene::IndexReader::closed

protected

const int32_t Lucene::IndexReader::DEFAULT_TERMS_INDEX_DIVISOR

static

int32_t Lucene::IndexReader::refCount

protected

The documentation for this class was generated from the following file:

- IndexReader.h

clucene.sourceforge.net